/*
 * Copyright (c) 2017 Digital Bazaar, Inc. All rights reserved.
 */
'use strict';

module.exports = class JsonLdError extends Error {
  /**
   * Creates a JSON-LD Error.
   *
   * @param msg the error message.
   * @param type the error type.
   * @param details the error details.
   */
  constructor() {
    let message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'An unspecified JSON-LD error occurred.';
    let name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'jsonld.Error';
    let details = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    super(message);
    this.name = name;
    this.message = message;
    this.details = details;
  }
};